using RMYY_CallCenter_Api.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RMYY_CallCenter_Api.Dal
{
    public  class T_QC_IndexCategory
    {
        public T_QC_IndexCategory()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_CategoryId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_QC_IndexCategory with(nolock)");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_CategoryId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add( Model.T_QC_IndexCategory model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_QC_IndexCategory(");
            strSql.Append("F_CategoryName,F_Layer,F_ParentId,F_Sort,F_Score,F_CreateOn,F_CreateBy,F_DeleteFlag,F_DeleteOn)");
            strSql.Append(" values (");
            strSql.Append("@F_CategoryName,@F_Layer,@F_ParentId,@F_Sort,@F_Score,@F_CreateOn,@F_CreateBy,@F_DeleteFlag,@F_DeleteOn)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Layer", SqlDbType.Int,4),
                    new SqlParameter("@F_ParentId", SqlDbType.Int,4),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Score", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteOn", SqlDbType.DateTime)};
            parameters[0].Value = model.F_CategoryName;
            parameters[1].Value = model.F_Layer;
            parameters[2].Value = model.F_ParentId;
            parameters[3].Value = model.F_Sort;
            parameters[4].Value = model.F_Score;
            parameters[5].Value = model.F_CreateOn;
            parameters[6].Value = model.F_CreateBy;
            parameters[7].Value = model.F_DeleteFlag;
            parameters[8].Value = model.F_DeleteOn;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update( Model.T_QC_IndexCategory model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_QC_IndexCategory set ");
            strSql.Append("F_CategoryName=@F_CategoryName,");
            strSql.Append("F_Layer=@F_Layer,");
            strSql.Append("F_ParentId=@F_ParentId,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_Score=@F_Score,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_DeleteFlag=@F_DeleteFlag,");
            strSql.Append("F_DeleteOn=@F_DeleteOn");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Layer", SqlDbType.Int,4),
                    new SqlParameter("@F_ParentId", SqlDbType.Int,4),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Score", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryName;
            parameters[1].Value = model.F_Layer;
            parameters[2].Value = model.F_ParentId;
            parameters[3].Value = model.F_Sort;
            parameters[4].Value = model.F_Score;
            parameters[5].Value = model.F_CreateOn;
            parameters[6].Value = model.F_CreateBy;
            parameters[7].Value = model.F_DeleteFlag;
            parameters[8].Value = model.F_DeleteOn;
            parameters[9].Value = model.F_CategoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_CategoryId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_QC_IndexCategory ");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_CategoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_CategoryIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_QC_IndexCategory ");
            strSql.Append(" where F_CategoryId in (" + F_CategoryIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public  Model.T_QC_IndexCategory GetModel(int F_CategoryId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_CategoryId,F_CategoryName,F_Layer,F_ParentId,F_Sort,F_Score,F_CreateOn,F_CreateBy,F_DeleteFlag,F_DeleteOn from T_QC_IndexCategory with(nolock)");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_CategoryId;

             Model.T_QC_IndexCategory model = new  Model.T_QC_IndexCategory();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public  Model.T_QC_IndexCategory DataRowToModel(DataRow row)
        {
             Model.T_QC_IndexCategory model = new  Model.T_QC_IndexCategory();
            if (row != null)
            {
                if (row["F_CategoryId"] != null && row["F_CategoryId"].ToString() != "")
                {
                    model.F_CategoryId = int.Parse(row["F_CategoryId"].ToString());
                }
                if (row["F_CategoryName"] != null)
                {
                    model.F_CategoryName = row["F_CategoryName"].ToString();
                }
                if (row["F_Layer"] != null && row["F_Layer"].ToString() != "")
                {
                    model.F_Layer = int.Parse(row["F_Layer"].ToString());
                }
                if (row["F_ParentId"] != null && row["F_ParentId"].ToString() != "")
                {
                    model.F_ParentId = int.Parse(row["F_ParentId"].ToString());
                }
                if (row["F_Sort"] != null && row["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(row["F_Sort"].ToString());
                }
                if (row["F_Score"] != null && row["F_Score"].ToString() != "")
                {
                    model.F_Score = int.Parse(row["F_Score"].ToString());
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(row["F_CreateBy"].ToString());
                }
                if (row["F_DeleteFlag"] != null && row["F_DeleteFlag"].ToString() != "")
                {
                    model.F_DeleteFlag = int.Parse(row["F_DeleteFlag"].ToString());
                }
                if (row["F_DeleteOn"] != null && row["F_DeleteOn"].ToString() != "")
                {
                    model.F_DeleteOn = DateTime.Parse(row["F_DeleteOn"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_CategoryId,F_CategoryName,F_Layer,F_ParentId,F_Sort,F_Score,F_CreateOn,F_CreateBy,F_DeleteFlag,F_DeleteOn ");
            strSql.Append(" FROM T_QC_IndexCategory with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_CategoryId,F_CategoryName,F_Layer,F_ParentId,F_Sort,F_Score,F_CreateOn,F_CreateBy,F_DeleteFlag,F_DeleteOn ");
            strSql.Append(" FROM T_QC_IndexCategory with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_QC_IndexCategory with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_CategoryId desc");
            }
            strSql.Append(")AS Row, T.*  from T_QC_IndexCategory T with(nolock)");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
    }
}
